var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Component, Host, h, Element, State } from '@stencil/core';
import { InjectVegaGlobalSlimmer, InjectVegaSlimmer, slotPlaceholder, } from 'vega-slimmer/core';
import { VegaTableFootRowRenderer } from './slimmers/renderers/vega-table-foot-row-renderer';
import { sanitizeVegaComponent } from '../../../utils/component';
import { VegaTableFootRowStateController } from './slimmers/controllers/vega-table-foot-row-state-controller';
import ResponsiveFormatFacade from '../../../helpers/formatter/responsive-map-formatter/responsive-format-facade';
import { VegaComponentUsageRuntimeMetricsSlimmer } from '../../../helpers/slimmers/component-usage-runtime-metrics';
import { PageResizeObserverSlimmer } from '../../../helpers/slimmers/page-resize-observer-slimmer';
import { getCurrentBreakpoint } from '../../../utils/breakpoints';
/**
 * @vegaVersion 2.68.1
 */
export class VegaTableFootRow {
  constructor() {
    this.globalSlimmers = {};
    this.vegaTableFootRowStateController = new VegaTableFootRowStateController();
    this.vegaTableFootRowRenderer = new VegaTableFootRowRenderer();
    this.vegaComponentUsageRuntimeMetricsSlimmer = new VegaComponentUsageRuntimeMetricsSlimmer();
    this.pageResizeObserverSlimmer = new PageResizeObserverSlimmer();
    this.currentBreakpoint = getCurrentBreakpoint();
    /**
     * Indicates whether the table has a expandable row.
     */
    this.hasExpandableRow = false;
  }
  render() {
    slotPlaceholder(h("slot", null));
    return sanitizeVegaComponent(h(Host, { class: {
        'column-divider': this.columnDivider,
        [`density-${ResponsiveFormatFacade.formatCustom(this.density)}`]: true,
      } }, this.vegaTableFootRowRenderer.render()), this.host);
  }
  static get is() { return "vega-table-foot-row"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["vega-table-foot-row.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["vega-table-foot-row.css"]
  }; }
  static get states() { return {
    "currentBreakpoint": {},
    "hasExpandableRow": {},
    "selectionType": {},
    "paddingX": {},
    "columnDivider": {},
    "draggable": {},
    "density": {}
  }; }
  static get elementRef() { return "host"; }
}
__decorate([
  InjectVegaGlobalSlimmer()
], VegaTableFootRow.prototype, "globalSlimmers", void 0);
__decorate([
  InjectVegaSlimmer()
], VegaTableFootRow.prototype, "vegaTableFootRowStateController", void 0);
__decorate([
  InjectVegaSlimmer()
], VegaTableFootRow.prototype, "vegaTableFootRowRenderer", void 0);
__decorate([
  InjectVegaSlimmer()
], VegaTableFootRow.prototype, "vegaComponentUsageRuntimeMetricsSlimmer", void 0);
__decorate([
  InjectVegaSlimmer()
], VegaTableFootRow.prototype, "pageResizeObserverSlimmer", void 0);
